#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated. 
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import verwaltungmysql
import sortieren
import types
import os
import gemeindekarteiweb
import optionen
import abkuerzungenmysql
import glob
import shutil
import time
import verschiedeneUtilities
import verwaltungMainServer
import gemeindeverwaltung

from reportlab.platypus import SimpleDocTemplate, BaseDocTemplate,PageTemplate,Paragraph,Spacer,Frame,Table,TableStyle,KeepTogether,PageBreak,ActionFlowable,Image,NextPageTemplate,CondPageBreak
from reportlab.platypus.doctemplate import IndexingFlowable
from reportlab.lib.styles import getSampleStyleSheet
from reportlab.rl_config import defaultPageSize
from reportlab.lib.pagesizes import A5
from reportlab.lib.units import inch, cm
from reportlab.lib import colors

PAGE_HEIGHT=defaultPageSize[1]
PAGE_WIDTH = defaultPageSize[0]
styles = getSampleStyleSheet()
heute = datumutilities.Datum()

class adressenDocTemplate(BaseDocTemplate):
   def __init__(self,filename,**kwargs):
      apply(BaseDocTemplate.__init__,(self,filename),kwargs)
      frame1 = Frame(x1=2*cm,y1=1.5*cm,width=6*cm,height=26*cm,id="1")
      frame2 = Frame(x1=8*cm,y1=1.5*cm,width=6*cm,height=26*cm,id="2")
      frame3 = Frame(x1=14*cm,y1=1.5*cm,width=6*cm,height=26*cm,id="3")
      #pt1 = PageTemplate(id="MultiColumns",frames=[frame1,frame2,frame3],onPage=self.eachPage)
      pt1 = PageTemplate(id="MultiColumns",frames=[frame1,frame2,frame3],onPage=self.eachPage,onPageEnd=self.eachPageEnd)
      frame3 = Frame(x1=2*cm,y1=1.5*cm,width=17*cm,height=26*cm,id="4")
      pt2 = PageTemplate(id="OneColumn",frames=[frame3],onPage=self.eachPage)
      self.addPageTemplates(pt1)
      self.addPageTemplates(pt2)
      self.style = styles["Normal"]
      self.style_body = styles["BodyText"]
      self.style_h3 = styles["Heading3"]
      # Achtung, Test:
      self.style_h3.spaceBefore = 0
      self.style_h3.spaceAfter = 0
      #self.allowSplitting = 0
      self.konferenz = ""
      self.unterkategorie = "" # ergnzt die Seitenberschriften von self.konferenz

   def eachPage(self,canvas,doc):
       if doc.page != 1:
           canvas.saveState()
           canvas.setFont("Helvetica-Bold", 12)
           canvas.setFillColor(colors.black)
           canvas.drawCentredString(10*cm, 28*cm, doc.konferenz)
           #canvas.drawCentredString(10*cm, 28*cm, doc.konferenz)
           canvas.setFont("Helvetica", 8)
           num = "Mein kleines EmK-Adressbuch, Seite %d" % doc.page
           canvas.drawCentredString(10*cm, 1*cm, num)
           canvas.restoreState()
       else:                   
           canvas.saveState()
           canvas.setFont("Helvetica", 42)
           canvas.setFillColor(colors.black)
           canvas.drawCentredString(10*cm, 15*cm, "Mein kleines")
           canvas.drawCentredString(10*cm, 12*cm, "EmK-Adressbuch")
           canvas.setFont("Times-Italic",20)
           canvas.drawCentredString(10*cm, 4.5*cm, "frisch gedruckt am %s" % heute.deutschesFormatText())   
           canvas.drawCentredString(10*cm, 3*cm, "von bezirksreiter4me")                   
           canvas.restoreState()
           
   def eachPageEnd(self,canvas,doc):
       if doc.page != 1:
           if doc.unterkategorie != "":
              canvas.saveState()
              canvas.setFont("Helvetica", 12)
              canvas.setFillColor(colors.black)
              canvas.drawCentredString(10*cm, 27.5*cm, doc.unterkategorie[:-1])
              # am Schluss muss "," weg.
              #canvas.drawCentredString(10*cm, 28*cm, doc.konferenz)
              canvas.setFont("Helvetica", 8)
              num = "Mein kleines EmK-Adressbuch, Seite %d" % doc.page
              canvas.drawCentredString(10*cm, 1*cm, num)
              canvas.restoreState()
              temp = doc.unterkategorie[:-1].split(",")
              # das letzte Komma nicht mit splitten!
              doc.unterkategorie = temp[-1] + ","
              # nur die letzte Kategorie bleibt fuer die naechste Seite, Komma inclusiv!
              
   
      

   def nameStatusKonferenz(self,dict,zuordnungen,umgekehrt="nein"):
      # bekommt einen dict aus der Personenkartei.
      text = ""
      titel, konferenz, status = "","",""
      if dict["Titel"] and dict["Titel"] != "-":
         titel = "%s " % dict["Titel"]
      if dict["Konferenz"] and dict["Konferenz"] != "-":
         konferenz = "%s" % dict["Konferenz"]
      #if dict["Status1"] and dict["Status1"] != "-":
      #   status = "%s" % dict["Status1"]
      status = zuordnungen.gemeindekartei.statusZusammenfassungKurz(dict)
      # nicht: statusZusammenfassung - wird zu lang, gibt Layout-Errors
      if umgekehrt == "nein":
         text = "%s%s %s" % (titel,dict["Vorname"],dict["Name"])
      elif umgekehrt == "ja":
         text = "%s, %s%s" % (dict["Name"],titel,dict["Vorname"])
      if konferenz and status:
         trenner = ":"
      else:
         trenner = ""
      text = "%s(%s%s%s)" % (text,konferenz,trenner,status)
      return text


   def bezirkAdding(self,templist,mz,zuordnungen):
         bezirke = zuordnungen.zuordnungenZuPerson(mz,nurBezirke=1)
         text = ""
         if bezirke:
               for b in bezirke:
                     text += "%s, " % b["Name"]
               templist.append(Paragraph("(Bezirk: %s)" % text[:-2],self.style))
         return templist 

   def conditionalAdding(self,templist,dict,category,name):
      check = dict.get(category)      
      if check and check != "-":
            temptext = "%s: %s" % (name,dict[category])
            templist.append(Paragraph(temptext,self.style))
      return templist

   def dictToParagraph(self,dict,zuordnungen,ueberschrift="",zusammen="ja",mitName="ja"):
      # Achtung, Test: es fehlen die Zweitnummern "Telefon2" etc.
      # zur Umwandlung vgl. auch "textutilities.privatStattDienstlich"
      dict = dict
      templist = []
      titel = ""
      if ueberschrift:
          templist.append(Paragraph("""%s""" % ueberschrift,self.style_h3))
      temptext1 = """<b>%s</b>""" % self.nameStatusKonferenz(dict,zuordnungen,umgekehrt="ja")
      temptext2 = "%s" % dict["Strasse"]
      temptext3 = "%s %s" % (dict["PLZ"],dict["Ort"])
      if mitName == "ja":
          templist.append(Paragraph(temptext1,self.style))
      templist.append(Paragraph(temptext2,self.style))
      templist.append(Paragraph(temptext3,self.style))
      templist = self.conditionalAdding(templist,dict,"Telefon","Tel.")
      templist = self.conditionalAdding(templist,dict,"Fax","Fax")
      templist = self.conditionalAdding(templist,dict,"Mail","E-Mail")
      templist = self.bezirkAdding(templist,dict["MZ"],zuordnungen)
      s = Spacer(1,0.2*cm)
      #self.allowSplitting = 1
      if zusammen == "ja":
          temp = KeepTogether([s] + templist)
          #temp = KeepTogether(templist+[s]) # so herum macht es manchmal Seitenumbruchsfehler!
          return temp
      else:          
          return templist

   def dictToEinrichtungPerson(self,einrichtung,zuordnungen,ueberschrift="",zusammen="ja",mitEinrichtungsname="ja"):
      # bekommt den Namen einer Einrichtung und eine Zuordnungen-Instanz.
      templist = []
      text = ""
      s = Spacer(1,0.1*cm)
      # Achtung, Test:
      c = CondPageBreak(3.0*cm)
      if ueberschrift:
          templist.append(c)
          # berschriften nicht allein unten in einer Spalte/Seite
          templist.append(Paragraph("""%s""" % ueberschrift,self.style_h3))
      einrichtung_dict = zuordnungen.eintragSuchfunktion({"Nr": einrichtung})[0]
      personen_dictarray = zuordnungen.personenZuZuordnung(einrichtung)
      personen_dictarray = zuordnungen.Textwerkzeug.privatStattDienstlichDictarray(personen_dictarray)
      if mitEinrichtungsname == "ja":
         text = "<b>%s</b>: " % einrichtung_dict["Name"]
      if personen_dictarray:
         text2 = ""
         for i in personen_dictarray:
            text2 += "%s, " % self.nameStatusKonferenz(i,zuordnungen)
         text += "%s" % text2[:-2]
      templist.append(Paragraph("""%s""" % text,self.style))
      if zusammen == "ja":
          temp = KeepTogether([s] + templist) # so aber auch? => 
          #temp = KeepTogether(templist+[s]) # so herum macht es manchmal Seitenumbruchsfehler!
          return temp
      else:          
          return templist

   def dictToBezirkDistrikt(self,einrichtung_dict,zuordnungen,ueberschrift="",mitEinrichtungsname="ja",mitPersonenadresse="nein"):
      templist = []
      text = ""
      s = Spacer(1,0.1*cm)
      # Achtung, Test:
      c = CondPageBreak(3.0*cm)
      if ueberschrift:
          templist.append(c)
          templist.append(Paragraph("""%s""" % ueberschrift,self.style_h3))
      comdict = {"Telefon1": "Telefon", "Fax1": "Fax", "Mail1": "E-Mail"}
      Nr = einrichtung_dict["Nr"]
      personen_dictarray = zuordnungen.personenZuZuordnung(Nr)
      adressen_dictarray = zuordnungen.adressenZuZuordnung(Nr)
      bank_dictarray = zuordnungen.bankZuZuordnung(Nr)
      if mitEinrichtungsname == "ja":         
         # Achtung, Test: 
         e = einrichtung_dict["Name"]
         e = e.replace("&","+")
         # Der XML-Parser von Reportlab hat einen Bug und steigt unter Win95 aus.
         # TODO: XML-Quoting vorsehen.
         templist.append(Paragraph("""<b>%s</b>""" % e,self.style))
      # Achtung, Test: statt if: try-except nehmen?
      if adressen_dictarray:         
         for d in adressen_dictarray:
            templist.append(Paragraph("""%s""" % d["Strasse"],self.style))
            for com in ("Telefon1","Fax1","Mail1"):
               if d[com] != "" and d[com] != "-":
                  templist.append(Paragraph("""%s: %s""" % (comdict[com],d[com]),self.style))
            templist.append(Paragraph("""%s %s""" % (d["PLZ"],d["Ort"]),self.style))
      if personen_dictarray:
         for d in personen_dictarray:
            if mitPersonenadresse=="nein":
               templist.append(Paragraph("""%s""" % self.nameStatusKonferenz(d,zuordnungen),self.style))
            elif mitPersonenadresse=="ja":
               persontext = """%(Vorname)s %(Name)s: %(Strasse)s, %(PLZ)s %(Ort)s, Telefon: %(Telefon)s, Fax: %(Fax)s, E-Mail: %(Mail)s""" % d
               templist.append(Paragraph(persontext,self.style))
      if bank_dictarray:
         for d in bank_dictarray:
            templist.append(Paragraph("""%s""" % d["BankName"],self.style))
            templist.append(Paragraph("""(BLZ %s) %s""" % (d["BLZ"],d["Konto"]),self.style))
      return KeepTogether([s] + templist)
      

class adressenDocTemplateA5(adressenDocTemplate):
   def __init__(self,filename,**kwargs):
      apply(BaseDocTemplate.__init__,(self,filename),kwargs)
      frame1 = Frame(x1=1.5*cm,y1=1*cm,width=5.5*cm,height=18.5*cm,id="1")
      frame2 = Frame(x1=8.3*cm,y1=1*cm,width=5.5*cm,height=18.5*cm,id="2")
      pt1 = PageTemplate(id="MultiColumns",frames=[frame1,frame2],onPage=self.eachPage,pagesize=A5)
      frame3 = Frame(x1=1.5*cm,y1=1*cm,width=12*cm,height=18.5*cm,id="4")
      pt2 = PageTemplate(id="OneColumn",frames=[frame3],onPage=self.eachPage,pagesize=A5)
      self.addPageTemplates(pt1)
      self.addPageTemplates(pt2)
      self.style = styles["Normal"]
      self.style.fontSize = 8
      self.style.fontName = "Helvetica"
      self.style.leading = 9
      self.style_body = styles["BodyText"]
      self.style_h3 = styles["Heading3"]
      # Achtung, Test:
      self.style_h3.spaceBefore = 0
      self.style_h3.spaceAfter = 0
      #self.allowSplitting = 0
      self.konferenz = ""

   def eachPage(self,canvas,doc):
       if doc.page != 1:
           canvas.saveState()
           canvas.setFont("Helvetica", 12)
           canvas.setFillColor(colors.black)
           canvas.drawCentredString(8*cm, 20.1*cm, doc.konferenz)
           canvas.setFont("Helvetica", 8)
           num = "EmK-Adressbuch, Seite %d" % doc.page
           canvas.drawCentredString(8*cm, 0.8*cm, num)
           canvas.restoreState()
       else:                   
           canvas.saveState()
           canvas.setFont("Helvetica", 32)
           canvas.setFillColor(colors.black)
           #canvas.drawCentredString(6.5*cm, 9*cm, "Mein kleines")
           canvas.drawCentredString(6.5*cm, 7.5*cm, "EmK-Adressbuch")
           canvas.setFont("Times-Italic",20)
           #canvas.drawCentredString(8*cm, 4*cm, "frisch gedruckt am %s" % heute.deutschesFormatText())   
           #canvas.drawCentredString(8*cm, 3*cm, "von Erzgebirge Buch & Medien")                   
           canvas.restoreState()

class docKonferenz(ActionFlowable):
    
   def __init__(self,konferenz):
      self.konferenz = konferenz
      ActionFlowable.__init__(self)

   def apply(self,doc):
      doc.konferenz = self.konferenz

class docUnterkategorie(ActionFlowable):
    
   def __init__(self,unterkategorie):
      self.unterkategorie = unterkategorie
      ActionFlowable.__init__(self)

   def apply(self,doc):
      if self.unterkategorie == "":
         doc.unterkategorie = ""
      else:
         doc.unterkategorie += self.unterkategorie + ","



class emkAdressenReportlabPDF:
   def __init__(self,MysqlDatenbank,Buchungsjahr,datei="test.pdf",format="A4"):
      self.zuordnungen = gemeindeverwaltung.ZuordnungenBearbeiten(MysqlDatenbank,Buchungsjahr)
      self.format = format
      self.datei = datei    
      self.Story = [] 
      self.STATUS = self.zuordnungen.optionen.status
      # self.STATUSLISTE = ["Sup","P","PiS","PiR","aoM","PaP","L","LpD","Lp","St","Pt","Gs","GsiR","Gr","GriA","GriR","MiG","W"]
      self.STATUSLISTE = ["P","PiS","PiR","aoM","PaP","Ld","L","LpD","Lp","St","Pt","Gs","GsiR","Gr","GriA","GriR","MiG","W"]
      self.KONFERENZLISTE = ["NJK","OJK","SJK"]
      self.DISTRIKT = self.zuordnungen.optionen.distrikte
      self.KONFERENZ = {"OJK": ("Ostdeutsche","A.7.2"),
                        "NJK": ("Norddeutsche","A.7.1"),
                        "SJK": ("Sddeutsche","A.7.3")}
      if self.format == "A5":
         self.doc = adressenDocTemplateA5(self.datei)
      elif self.format == "A4":
         self.doc = adressenDocTemplate(self.datei)
      self.status = self.STATUS.keys()

   def personenKonferenz(self,konferenz):
      tempstory = []
      for s in self.STATUSLISTE:
         ueberschrift =  self.STATUS[s]["b"]
         #liste = self.zuordnungen.gemeindekartei.eintragSuchfunktion({"Konferenz": konferenz, "Status1": s})
         # Achtung, Test:
         liste = self.zuordnungen.gemeindekartei.oderListeAbfragen(s, ["Status1","Status2","Status3","Status4","Status5"],sortierkategorie="Name",zusatzbedingung="""and Konferenz like "%s" """ % konferenz)
         liste = self.zuordnungen.Textwerkzeug.privatStattDienstlichDictarray(liste)
         # Achtung, Test:
         tempstory.append(docUnterkategorie(s)) # fuer die Seitenueberschrift
         for eintrag in liste:
            p = Spacer(1,0.1*cm)
            try:
               p = self.doc.dictToParagraph(dict=eintrag,zuordnungen=self.zuordnungen,ueberschrift=ueberschrift,zusammen="ja",mitName="ja")
            except:
               if ueberschrift:
                  tempstory.append(Spacer(1,0.2*cm))   
                  tempstory.append(Paragraph(ueberschrift,self.doc.style_h3)) # fr Status ohne Eintrge
            tempstory.append(p)
            ueberschrift = "" # wird zurckgesetzt nach dem ersten Durchgang
      return tempstory

   def bezirkeDistrikteKonferenz(self,konferenz):
      tempstory = []
      dictarray = self.zuordnungen.alleDistrikteKonferenz(konferenz)
      tempstory.append(Paragraph("""%s Distrikte""" % self.zuordnungen.DistrikteKonferenz[konferenz],self.doc.style_h3))
      for d in dictarray:
         tempstory.append(self.doc.dictToBezirkDistrikt(d,self.zuordnungen))
      tempstory.append(Paragraph("""%s Bezirke""" % self.zuordnungen.BezirkeKonferenz[konferenz],self.doc.style_h3))
      dictarray = self.zuordnungen.alleBezirkeKonferenz(konferenz)
      for d in dictarray:
         tempstory.append(self.doc.dictToBezirkDistrikt(d,self.zuordnungen))
      return tempstory

   def ordnungsnummerPersonen(self,ordnungsnummer,ueberschriftstiefe=4,mode="BezirkDistrikt",mitPersonenadresse="nein"):
      tempstory = []
      dictarray = self.zuordnungen.zuordnungenUnterkategorien(ordnungsnummer)
      ueberschrift = ""
      for i in dictarray:
         mitEinrichtungsname = "ja"
         test = len(string.split(i["Nr"],"."))
         if test == ueberschriftstiefe:
            ueberschrift = """%s %s""" % (i["Nr"],i["Name"])
            #tempstory.append(docUnterkategorie(ueberschrift))
            mitEinrichtungsname = "nein" # sonst erscheint der Name zweimal
            #continue
         if mode == "EinrichtungPerson":
            tempstory.append(self.doc.dictToEinrichtungPerson(i["Nr"],self.zuordnungen,ueberschrift=ueberschrift,mitEinrichtungsname=mitEinrichtungsname))
         elif mode == "BezirkDistrikt":
            tempstory.append(self.doc.dictToBezirkDistrikt(einrichtung_dict=i,zuordnungen=self.zuordnungen,ueberschrift=ueberschrift,mitEinrichtungsname=mitEinrichtungsname,mitPersonenadresse=mitPersonenadresse))
         ueberschrift = ""
      return tempstory

   def buildStory(self):
      # Achtung, Test:
      konferenzliste = self.KONFERENZLISTE # nur OJK = [1:2]
      self.Story.append(Image("EmK-Zeichen1.jpg",width=22,height=22,kind="%"))
      
      self.doc.konferenz = "A.1 Bischfe und kirchliche Verwaltungsstellen"    
      self.Story.append(PageBreak()) # fr die erste Seite
      # Achtung, Test:
      self.Story += self.ordnungsnummerPersonen("A.1",ueberschriftstiefe=3,mode="BezirkDistrikt")
      self.Story.append(docKonferenz("A.2 Beauftragte und Gremien der Zentralkonferenz"))
      self.Story.append(PageBreak())
      self.Story += self.ordnungsnummerPersonen("A.2",ueberschriftstiefe=3,mode="EinrichtungPerson")
      for i in ("A.3","A.4","A.5","A.6"):
         dict = self.zuordnungen.eintragSuchfunktion({"Nr": i})[0]
         self.Story.append(docKonferenz("%s %s" % (i,dict["Name"])))
         self.Story.append(PageBreak())
         self.Story += self.ordnungsnummerPersonen(i,ueberschriftstiefe=3,mode="BezirkDistrikt")
         
      for k in konferenzliste:
         self.Story.append(docKonferenz("%s Jhrliche Konferenz" % (self.KONFERENZ[k])[0])) 
         # ein Ereignis wird ausgelst, um die berschrift ber die Seite zu ndern.
         self.Story.append(PageBreak())
         self.Story.append(docUnterkategorie("")) # zurcksetzen
         self.Story += self.ordnungsnummerPersonen(self.KONFERENZ[k][1])
         self.Story.append(PageBreak())
         self.Story += self.personenKonferenz(k)

      # Achtung, Test: die berschrift wird jetzt am Seitenende gedruckt! => verbessern

      self.Story.append(NextPageTemplate("OneColumn"))
      self.Story.append(docKonferenz("B. Zentralkonferenz Mittel- und Sdeuropa"))
      self.Story.append(PageBreak())
      self.Story.append(docUnterkategorie(""))
      #self.Story.append(PageBreak())
      self.Story += self.ordnungsnummerPersonen("B",ueberschriftstiefe=2,mode="BezirkDistrikt",mitPersonenadresse="ja")
      self.Story.append(docKonferenz("C. Zentralkonferenz in Nordeuropa"))
      self.Story.append(PageBreak())
      self.Story += self.ordnungsnummerPersonen("C",ueberschriftstiefe=2,mode="BezirkDistrikt",mitPersonenadresse="ja")
         
      self.doc.build(self.Story)
      f = open(self.datei,"rb")
      string = f.read()
      f.close()
      return string




        ########################
      ##  self.Story.append(Paragraph("Bezirke",self.doc.style_h3))
##        for b in bezirke:
##            alle = self.eintragSuchfunktion({"Konferenz": k, "Bezirk1": b})
##            alle += self.eintragSuchfunktion({"Konferenz": k, "Bezirk2": b})
##            templist = [Paragraph("<b>%s</b>" % b, self.doc.style)]
##            for a in alle:
##                try:
##                    eintrag = "%s, %s (%s)" % (a["Nachname"],a["Vorname"],a["Status"])
##                    templist.append(Paragraph(eintrag,self.doc.style))
##                except:
##                    pass # wenn nichts gefunden wurde
##            templist.append(Spacer(1,0.2*cm))
##            self.Story.append(KeepTogether(templist))
        ########################    
      
        #######################
       ## self.Story.append(NextPageTemplate("OneColumn"))
##        self.Story.append(PageBreak())
##        self.Story.append(Paragraph("Werke/Einrichtungen",self.doc.style_h3))
##        for w in werke:
##            alle = self.zuordnungen.eintragSuchfunktion({"WerkEinrichtung": w,"Konferenz": k})
##            templist = [Paragraph("<b>%s</b>" % w,self.doc.style)]
##            for einzel in alle:
##                aufgabe,name = einzel["Aufgabe"],einzel["Name"]
##                mz_eintrag = None
##                if einzel["MZ"] != "0":
##                    mz_eintrag = (self.schluesselSuchen(einzel["MZ"]))[0]
##                aufgabe_eintrag = ""
##                if aufgabe != "-" and aufgabe != "" and aufgabe != "None":
##                    aufgabe_eintrag = "%s: " % aufgabe
##                name_eintrag = ""
##                if name != "-":
##                    name_eintrag = "%s" % name
##                status_eintrag = ""
##                if mz_eintrag is not None and mz_eintrag and mz_eintrag["Status"] not in ("","-"):
##                    try:
##                        status_eintrag = "(%s)" % self.abkuerzungBedeutung(mz_eintrag["Status"])
##                    except:
##                        pass # fr "schlechte" Eintrge
##                eintrag = "%s%s %s" % (aufgabe_eintrag,name_eintrag,status_eintrag)
##                templist.append(Paragraph(eintrag,self.doc.style))
##                if einzel["AdresseGesondert"] == "ja":
##                    try:
##                        templist += self.doc.dictToParagraph(mz_eintrag,zusammen="nein",mitName="nein")
##                    except:
##                        pass
##            templist.append(Spacer(1,0.2*cm))
##            self.Story.append(KeepTogether(templist))
##        self.Story.append(NextPageTemplate("MultiColumns"))
