#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
## Eine Klasse, die verschiedenste eigene Textoperationen ermglicht
## Funktioniert z.T. nur mit Instanzen
import textutilities
import re
import sys
import normalDate
import datumutilities
import locale
import string
import types

class Sortieren:
    
    def __init__(self):
        pass

    def mapAll(self,listordict,funktion,nichtaendern=[]):
         """Wendet die Funktion, ggf. mit Parameter, auf
         eine Liste von Dicts bzw. Liste von Liste usw. an, gibt einen einen neuen
         Listdict bzw. ListList (auch bei ListOfTuples!) zurck.
         Es werden zwei verschiedene Codeblcke verwendet,
         damit man nicht in den Schleifen Fallunterscheidungen
         mit Performance-Einbuen hinnehmen mu. In nichtaendern ist ggf. eine
         Liste mit Schlsseln, die in keiner Zeile gendert werden sollen.
         Funktioniert auch fr einen Dict, der Listen als Werte enthlt, z.B.
         in gemeindekarteiweb beim nderungsvergleich. Das praktische ist dabei,
         da nun keine besonderen Klassen fr diese Objektarten mhsam definiert
         werden mssen.
         TODO: Noch robuster machen gegen falsche Objekttypen,
         die versehentlich bergeben werden."""
         if listordict == {} or listordict == []:
             return listordict
         if type(listordict) is types.DictType:
             # Wir betrachten nur den Fall eines einzigen Dicts, nicht einer
             # Liste von Dicts. Das gengt fr "nderungsformular" aus gemeindkarteiweb.
             temp = listordict.values()[0]
             # ein Probeelement...
             if type(temp) is types.ListType or type(temp) is types.TupleType:
                 # ein DictOfLists?
                 return self.mapAllDictOfLists(listordict,funktion,nichtaendern)
             else:
                 # oder ein einfacher Dictionary?
                 return self.mapAllDict(listordict,funktion,nichtaendern)
         elif type(listordict) is types.ListType or type(listordict) is types.TupleType:
             if type(listordict[0]) is types.DictType:
                 return self.mapAllListOfDicts(listordict,funktion,nichtaendern)
             elif type(listordict[0]) is types.ListType or type(listordict[0]) is types.TupleType:
                 return self.mapAllListOfLists(listordict,funktion,nichtaendern)

    def mapAllDict(self,dict,funktion,nichtaendern):
        neudict = {}
        for key, value in dict.items():
            if key in nichtaendern:
                neudict[key] = value
            else:
                neudict[key] = funktion(value)
        return neudict
                

    def mapAllDictOfLists(self,dictoflists,funktion,nichtaendern):
        # nur ein Dict, keine Liste von Dicts s.mapAll
        neudict = {}
        for key,value in dictoflists.items():
            templist = []
            if key in nichtaendern:
                templist = value[:] #Achtung echte Kopie!!
            else:
                templist = [funktion(x) for x in value]
            neudict[key] = templist
        return neudict

    def mapAllListOfDicts(self,liste,funktion,nichtaendern):
        neueliste = [] 
        for zeile in liste:
            dictzeile = {}
            for element in zeile.keys():
                if type(zeile[element]) is types.ListType or type(zeile[element]) is types.TupleType:
                    # wenn der innere Dict seinerseits Listen/Tupel enthlt. s. z.B.
                    # bei gemeindekarteiweb beim nderungsvergleich (-> Nein, eben nicht!)
                    templist = []
                    for i in dictzeile[element]:
                        if i in nichtaendern:
                            templist.append(i)
                        else:
                            templist.append(funktion(i))
                    dictzeile[element] = templist
                else:
                    if element in nichtaendern:
                        dictzeile[element] = zeile[element]
                    else:
                        dictzeile[element] = funktion(zeile[element])
            neueliste.append(dictzeile)
        return neueliste

    def mapAllListOfLists(self,liste,funktion,nichtaendern):
        neueliste = []
        for zeile in liste:
            neuezeile = []
            for element in zeile:
                neuezeile.append(funktion(element))
            neueliste.append(neuezeile)
        return neueliste

    def listeAusDictarray(self,dictarray,kategorie):
        try:
            return [x[kategorie] for x in dictarray]
        except:
            return []

    def umlaut_ascii(self,wert):
        tausch = {'':'ae','':'oe','':'ue','':'Ae','':'Oe','':'Ue','':'ss'}
        for j in tausch.keys():
            wert = string.replace(wert,j,tausch[j])
            wert = string.lower(wert)
        return wert

    def emk_normiert(self,wert):
        """Bekommt einen Wert der Form "A.2.2.20" und
        normiert auf "A.00002.00002.00020" """
        s = string.split(wert,".")
        temp = s[0]
        for i in range(1,len(s)):
            temp += """.%05d""" % int(s[i])
        return temp

    def emk_normiert_dict(self,dict):
        return self.emk_normiert(dict["Nr"])

    def emk_ordnungsnummer_sort(self,dictlist):
        try:
            return self.strans(liste=dictlist,metrik=self.emk_normiert_dict)
        except:
            return dictlist

    def paarebilden(self,element,M,p):
        if p is None:
            return (M(element),element)
        else:
            return (M(element,p),element)
    
    def strans(self,liste,metrik,metrikparameter=None):
        ## Schwartz'sche Transformation nach Python-FAQ 4.51       
        paarmatrix = [self.paarebilden(element,metrik,metrikparameter) for element in liste]
        paarmatrix.sort(lambda x,y: cmp (x[0], y[0]))
        return [x[1] for x in paarmatrix]

    def alphabethSort(self,liste):
        return self.strans(liste=liste,metrik=self.umlaut_ascii)
                               
         
    
   
