#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
## Eine Hilfs-Klasse, die verschiedenste Textoperationen ermglicht

import re
import sys
import os
import normalDate
import datumutilities
import string
import sortieren
import time
import verschiedeneUtilities
import zipfile
import shutil

class Regexes:
     def __init__(self):
        self.datumsform = re.compile(r"((\d?\d)\.\s?(\d?\d)\.\s?(\d\d\d\d))")
        self.datumstext = re.compile(r"((\d?\d)\.\s?(Januar|Februar|Mrz|April|Mai|Juni|Juli|August|September|Oktober|November|Dezember)\s?(\d\d\d\d))")
        self.monate = {"Januar":"01", "Februar":"02", "Mrz":"03", "April":"04","Mai":"05","Juni":"06","Juli":"07","August":"08","September":"09","Oktober":"10","November":"11","Dezember":"12"}

class Textutilities:
    def __init__(self):
         self.win, self.win_nt = verschiedeneUtilities.plattformTesten()

    def csvdatei_einlesen(self,datei="/home/martin/skripte/python/gemeindekartei.txt",trenner="\t",datumumwandeln="nein",nichtaendern=["Telefon","Fax", "EMail"]):
        """Spaltenberschriften als erste Zeile werden nicht gesondert behandelt!
        Rckgabeformat: Liste von Liste."""
        # *** TODO: Probleme bei leeren Datenfeldern? (reprsentiert z.B. von zwei aufeinanderfolgenden Tabs)
        sortierwerkzeug = sortieren.Sortieren()
        rueck_matrix = []
        try:
            f = open(datei,'r')
        except:
            print "Wo ist Datei %s?" %datei
            return 0
        inhalt = f.readlines()
        ## inhalt = map(lambda x: string.rstrip(x), inhalt)
        ## Alle angehngten Returns weg => nein - Schwierigkeiten bei
        ## Leerfeldern. Wird in importUmwandeln pro Feld gemacht s.u.
        kategorien = string.split(inhalt[0],trenner)
        laenge = len(kategorien)
        ## print kategorien
        for i in inhalt:
            temp = string.split(i,trenner)
            if len(temp) != laenge:
                # print "Content-type: text/html\n"
                print "Importierte Datenbank %s ist inkonsistent bei Element %s." %(datei,temp)
                return 0
            else:
                rueck_matrix.append(temp)        
        f.close()
        # Sonderbehandlungen fr jedes Datenfeld:
        rueck_matrix = sortierwerkzeug.mapAll(rueck_matrix,funktion=self.importUmwandeln)
        if datumumwandeln == "ja":            
            temp = sortierwerkzeug.mapAll(rueck_matrix,funktion=self.datumParsen,nichtaendern=nichtaendern)
            return temp
        else:
            return rueck_matrix

    def alsDictionary(self,spalten,array):
        # macht aus einem Array von Array ein
        # Array von Dictionaries, jeweils mit den
        # Namen aus "spalten" als Schlssel
        temparray = []
        for i in array:
            tempdict = {}
            for j in range(len(spalten)):
                tempdict[spalten[j]] = i[j]
            temparray.append(tempdict)
        return temparray    

    def importUmwandeln(self,string):
         """Gibt an, wie jedes einzelne Datenfeld - unabhngig von
         datumParsen - noch behandelt werden soll."""
         # Einige Tabellenkalkulationen exportieren mit
         # besonderen "Text-Trenner"-Zeichen.
         string = string.replace('\"','')
         string = string.replace("\'","")
         string = string.strip()
         # keine fhrenden oder angehngten Spaces usw.
         return string
         

    def datumParsen(self,string):
        """gibt ein erkanntes Datum als ISO-String
        JJJJ-MM-TT zurck, sonst den String selbst.
        Erlaubte Eingabeformate: "TT/MM/JJJJ" oder "TT.MM.JJJJ"
        oder "TT. Monatsname(deutsch ohne Abkrzung: "September") JJJJ".
        Ist tolerant gegen fehlende Spaces.
        Damit nicht jedes Textutilities-Objekt die komplizierten Regexes
        kompilieren mu, erscheinen sie nur hier und nicht in __init__."""
        datumsform = re.compile(r"((\d?\d)[\.\/]\s?(\d?\d)[\.\/]\s?(\d\d\d\d))")
        # *** TODO: ggf. noch abgekrzte Monatsnamen wie Apr. oder Mrz. behandeln.
        datumstext = re.compile(r"((\d?\d)\.\s?(Januar|Februar|Mrz|April|Mai|Juni|Juli|August|September|Oktober|November|Dezember)\s?(\d\d\d\d))")
        monate = {"Januar":"01", "Februar":"02", "Mrz":"03", "April":"04","Mai":"05","Juni":"06","Juli":"07","August":"08","September":"09","Oktober":"10","November":"11","Dezember":"12"}
        mobj = datumsform.search(string)
        if mobj is not None:
            # Korrekte Vornullen:
            tag = "%02d" % int(mobj.group(2))
            monat = "%02d" % int(mobj.group(3))
            jahr = "%04d" % int(mobj.group(4))
            return "%s-%s-%s" % (jahr,monat,tag)
        mobj = datumstext.search(string)
        if mobj is not None:
            tag = "%02d" % int(mobj.group(2))
            temp = mobj.group(3)
            jahr = "%04d" % int(mobj.group(4))
            monat = monate[temp]
            return "%s-%s-%s" % (jahr,monat,tag) 
        # Wenn kein Treffer:
        return string
        

    def csvDateiSchreiben(self,matrix,dateiname,trenner="\t",alsString="nein"):
         """Schreibt eine Liste von einer Liste in eine Datei,
         berschreibt ggf. ohne Nachfrage!"""
         string1 = ""         
         for zeile in matrix:
              for spalte in zeile:
                   string1 += """%s%s""" % (spalte,trenner)
              string1 = string1[:-1] + '\n'
              # letzter Tab weg, statt dessen Return
              # *** Achtung bei Windows wg. Zeilentrenner! ***
              # Automatische Umwandlung beim Schreiben?
              # ggf. os.linesep statt "\n" verwenden.
         if alsString == "ja":
              return string1
         else:
              try:
                   file = open(dateiname,'w') 
                   file.write(string1)
                   file.close()
                   return 1
              except:
                   # zur Lesbarkeit in CGI-Umgebungen:
                   print "Content-type: text/html\n"            
                   print "<H3>Konnte nicht in Datei %s schreiben!</H3>" % dateiname
                   return 0
    
    def extract_tags(self, starttag, endtag, startposition, inhalt,mitTags="ja"):
        ## sucht in einem XML/HTML(hnlichen)-String zwischen denen als Regex-Objekt
        ## angegebenen Tags Tabellen usw.
        startobj = starttag.search(inhalt, startposition)
        if not startobj:
            ## wenn kein Treffer:
            return ('',0)     
        endobj = endtag.search(inhalt, startposition)
        if mitTags == "ja":
             startposition = startobj.start()
             endposition = endobj.end()
        elif mitTags == "nein":
             startposition = startobj.end()
             endposition = endobj.start()
        # print startposition, endposition
        if (startposition <= endposition):    
            extractstring = inhalt[startposition:endposition]
            return (extractstring, endposition)
        else:
            sys.exit("Ober- und Untergrenze vertauscht in textutilities.extract_tags!")
       

    def remove_tags(self, starttag, endtag, inhalt,mitTags="ja"):
        ## Beseitigt aus einem Text alles zwischen starttag und endtag
        ## auch bei mehreren Vorkommen. starttag und endtag sind
        ## re-Objekte, s.o. Bei mitTags = "ja" werden auch die Tags mitgelscht.
        position = 0
        ausgabe = ""
        ##temp = ""
        while 1:
            startobj = starttag.search(inhalt,position)
            if not startobj:
                 ## fr den "Schwanz":
                 if mitTags == "ja":
                      ausgabe = ausgabe+inhalt[position:]
                 else:
                      ausgabe = ausgabe+inhalt[endobj.start():]
                 break                
            else:
                 endobj = endtag.search(inhalt,position)
                 startposition = startobj.start()
                 endposition = endobj.end()
                 if mitTags == "ja":
                      ausgabe = ausgabe+inhalt[position:startposition]
                 else:
                      ausgabe = ausgabe+inhalt[position:startobj.end()]
                 position = endposition                
        return ausgabe

    def bildschirmLoeschen(self):
         """Arbeitet mit ANSI-Escape-Sequenzen. Fr DOS nicht vergessen,
         ansi.sys einzubinden."""
         print "\033[2J"
         print "\033[0;0H"

    def konfigurationEinlesen(self,text):
         """Liest einen Text (z.B. aus einer Konfigurationsdatei) ein, gibt die Daten
         in einem Dictionary zurck. Primitiv und nicht sehr fehlertolerant. Windows-geeignet?
         (Wegen Zeilenendezeichen)"""
         alleZeilen = text.split("\n")
         datendict = {}
         for i in alleZeilen:
              try:
                   if i[0] == "#":
                        # Kommentarzeilen berspringen.
                        continue
                   i = i.rstrip()
                   templist = i.split("=")
                   datendict[templist[0]] = "%s" % templist[1]
              except:
                   # hier werden z.B. leere oder falsche Zeilen behandelt:
                   pass
         return datendict

    def schluesselworteFinden(self,text,wortliste,ohneSpaces="ja"):
         if ohneSpaces == "ja":
              text = text.strip()
              wortliste = [i.strip() for i in wortliste]
         templist = []
         for i in wortliste:
              if text.find(i) != -1:
                   templist.append(i)
         return templist

    def schluesselworteExtrahieren(self,text,wortliste,ohneSpaces="ja"):
         """Entfernt aus einem String alle Wrter aus Wortliste."""
         if ohneSpaces == "ja":
              text = text.strip()
              wortliste = [i.strip() for i in wortliste]
              # wenn text und wortliste aus einer Datenbank o.a. stammen, knnten vorne oder hinten
              # z.B. Spaces sein.
         for wort in wortliste:
              text = text.replace(wort,"")
         return text

    def abkuerzungenTesten(self,text,wortliste):
         """Soll einen Text darauf testen, ob er lediglich eine Anzahl von Abkrzungen
         enthlt, ggf. getrennt durch Spaces, Kommas usw. z.B. fr Tests von
         Datenbankfeldern."""
         ohne_schluessel_text = self.schluesselworteExtrahieren(text,wortliste,ohneSpaces="ja")
         dict = {" ": None, "\n": None, ",": None, ";": None, "\"": None, "\'": None}
         # so nutzen wir den schnellen Hash-Algorithmus der dict-Klasse, um ggf. Trenner-
         # zeichen u.. zu entfernen.
         returntext = ""
         for i in ohne_schluessel_text:
              if dict.has_key(i):
                   continue
              else:
                   returntext += i
         # wenn returntext immer noch "", dann waren im zu testenden Text nur
         # gltige Abkrzungen.
         return {"TestText": returntext,"ReduzierterText": ohne_schluessel_text}

    def stringErsetzenDatei(self,datei,stringalt,stringneu):
         """Eine sichere Methode, einen String zu ersetzen in einer Datei.
         bercksichtigt das verzgerte Setzen von Rechten bei Windows usw."""
         os.chmod(datei,0777)
         tempfile = open(datei,"rb")
         inhalt = tempfile.read()
         tempfile.close()
         inhalt = string.replace(inhalt,stringalt,stringneu)
         os.chmod(datei,0777)
         if self.win:
              time.sleep(1)            
              # eine Zeitschleife, weil (liegt es daran?) in Windows
              # manchmal die Schreibberechtigung zu spt gesetzt wird.
         tempfile = open(datei,"wb")
         tempfile.write(inhalt)
         tempfile.close()

    def openOfficeLesen(self,datei):
         """Liest die content.xml-Datei eines OO-"Archivs"."""
         z = zipfile.ZipFile(datei,"r")
         inhalt = z.read("content.xml")
         z.close()
         return inhalt

    def openOfficePagebreakstyle(self):
         return """ <style:style style:name="P2000" style:family="paragraph" style:parent-style-name="Standard"><style:properties fo:break-after="page"></style:properties></style:style>"""

    def openOfficePagebreakstyleEinsetzen(self,content):
         if content.find("style:name=\"P2000\"") == -1:
              return content.replace("""</office:automatic-styles>""",self.openOfficePagebreakstyle()+"""</office:automatic-styles>""")
         else:
              return content

    def openOfficeMergetextPruefen(self,text):
         """Manche XML-Styles machen bei dieser primitiven Merge-Methode Probleme,
         deshalb dieser Test. Achtung, berall nur reine ASCII-Zeichen nehmen, keine Umlaute!"""
         rueckgabe = text
         flag = 1
         testdict = {"text:anchor-type=\"page\"": {"Beschreibung": "Verankerung an der Seite","Ersatz": "Verankerung am Absatz"}}
         # Dieser testdict kann ergnzt werden.
         for style in testdict.keys():
              if rueckgabe.find(style) != -1:
                   warntext = """Problem: Ihr(e) OpenOffice-Dokument(vorlage) enthaelt irgendwo das Element "%s" (XML: %s). Ersetzungsvorschlag: "%s".#####""" % (testdict[style]["Beschreibung"],style,testdict[style]["Ersatz"])
                   # Achtung, Test:
                   print "Content-type: text/html\n"
                   print "<H3>"+warntext+"</H3>"
                   flag = 0
         return flag
              

    def openOfficeMerge(self,content1,content2,pagebreak="ja"):
         """Ergnzt bei der content.xml-Datei des ersten OO-Archivs in <office:body> den Inhalt von
         <office:body> der zweiten Datei. Nur die automatic-styles der ersten Datei werden bernommen."""
         body_start = re.compile(r"<office:body>")
         body_end = re.compile(r"<\/office:body>")
         body_1 = self.extract_tags(body_start,body_end,0,content1,mitTags="nein")[0]
         body_2 = self.extract_tags(body_start,body_end,0,content2,mitTags="nein")[0]
         self.openOfficeMergetextPruefen(body_2)
         content_neu = self.remove_tags(body_start,body_end,content1,mitTags="nein")
         if pagebreak == "ja":
              content_neu = self.openOfficePagebreakstyleEinsetzen(content_neu)
              return content_neu.replace("<office:body>","<office:body>"+body_1+"""<text:p text:style-name="P2000" />"""+body_2)
         else:
              return content_neu.replace("<office:body>","<office:body>"+body_1+body_2)
         

    def openOfficeErsetzen(self,datei,inhalt,neuedatei=None):
         datei = datei
         if neuedatei:
              shutil.copyfile(datei,neuedatei)
              datei = neuedatei
         # Achtung, Windows-Falle?
         # os.chmod(datei,0777)
         # evtl. noch s.o.:
         #if self.win:
         #     time.sleep(1)
         z = zipfile.ZipFile(datei,"r")
         zipinfo = z.getinfo("content.xml")
         z.close()
         z = zipfile.ZipFile(datei,"a")
         z.writestr(zipinfo,inhalt)
         z.close()

  

    def openOfficeStringUtf8(self,string):
         tempstring = unicode(string,"latin-1").encode("utf-8")
         return tempstring

    

    def openOfficeStringErsetzenDatei(self,datei,stringalt,stringneu):
         tempstring = self.openOfficeStringUtf8(stringneu)
         # wenn Umlaute etc. als neuer String eingesetzt werden.
         inhalt = self.openOfficeLesen(datei)
         inhalt = inhalt.replace(stringalt,tempstring)
         # stringalt darf keine Umlaute enthalten!
         self.openOfficeErsetzen(datei,inhalt)
         return 1    

    def privatStattDienstlich(self,dict):
        """Setzt bei  nicht vorhandener Dienstadresse die Privatadresse ein.
        Speziell fr Datenbank vom Typ emkadressen_neu"""
        trans = {"Strasse": "PrivatStrasse",
                 "Land": "PrivatLand",
                 "PLZ": "PrivatPLZ",
                 "Ort": "PrivatOrt",
                 "Telefon": "PrivatTelefon",
                 "Mail": "PrivatMail",
                 "Handy": "PrivatHandy",
                 "Fax": "PrivatFax"}
        tempdict = {}
        tempdict.update(dict)
        try:
             for t in trans.keys():
                  if tempdict[t] == "-" or tempdict[t] == "":
                       tempdict[t] = tempdict[trans[t]]
        except:
             pass # wenn ein leerer dict bergeben wurde.
        return tempdict

    def privatStattDienstlichDictarray(self,dictarray):
        # Achtung, neues Dictarray muss erzeugt werden! 
        tempdictarray = []
        try:
             for i in dictarray:
                 tempdictarray.append(self.privatStattDienstlich(i))
             return tempdictarray
        except:
             return dictarray # leerer dictarray s.o.
         
              
              
        
        
        
    
