#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.

import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import pickle
#import sortieren
import MySQLdb
import MySQLdb.converters
import time
import sortieren
import time
import os
import zipfile
import verschiedeneUtilities
import verwaltungMainServer
# import optionen
#import verwaltungMain 

EINZELPLATZ = 1

class MySQLZugriff:
    # Hier wird der Zugriff auf alle Gemeinde-Datenbanken definiert
    # die Spezialisierungen wie "Gemeindekartei" werden dann davon abgeleitet
    # jede Tabelle (wie Gemeindekartei,Veranstaltungen,Baukonto... sollte
    # ein eigenes Objekt sein. Zur Initialisierung wird eine geffnete
    # Datenbankverbindung bentigt.

    def __init__(self,MysqlDatenbank,datenbank,tabelle):
        # datenbank wird nur aus Kompatibilittsgrnden
        # noch bergeben. Kann bei einer berarbeitung
        # der Subklassen wegfallen.
        self.Tabellenname = tabelle      
        self.Datenbank = MysqlDatenbank
        self.Cursor = self.Datenbank.cursor()
        self.Cursor.execute("select database()")
        self.Datenbankname = self.Cursor.fetchone()[0]
        self.Textwerkzeug = textutilities.Textutilities()
        self.Datumwerkzeug = datumutilities.Datum()
        self.Sortierwerkzeug = sortieren.Sortieren()
        self.win = 0
        self.win_nt = 0
        # Achtung, die Plattformtests sind fr die Server-Version ggf. wegzulassen:
        if EINZELPLATZ:
            self.win, self.win_nt = verschiedeneUtilities.plattformTesten()
            self.mysqldump = "mysqldump"
            self.mysql = "mysql"
            if self.win and not self.win_nt:
                # bei NT / XP wird aufgerufen wie bei Linux
                self.mysqldump = "start mysqldump.exe"
                self.mysql = "start mysql.exe"
        #import optionen
        # erst hier importieren, weil das Optionen-Objekt selbst von
        # der Klasse MysqlZugriff abgeleitet ist - es gibt sonst Fehlermeldungen.
        #self.Optionswerkzeug = optionen.Optionen(self.Datenbank)
        # Achtung, so erreicht man eine Endlosrekursion!!!
        #self.Sortierwerkzeug = sortieren.Sortieren()
        try:
            self.Spaltennamen = self.holeSpaltennamen()
            self.Spaltenbeschreibung = self.spaltenBeschreibung()
            self.leererEintrag = self.holeLeerenEintrag()
        except:
            # Subklassen, die diese Funktionen nicht bieten knnen (z.B. optionen.DummyOptionen)
            # sollen auch initialisiert werden. So lassen sich ggf. Verbindungen auch zu leeren Datenbanken herstellen.
            pass
        self.datum_mysql = re.compile(r"((\d\d\d\d)-(\d\d)-(\d\d))")
        # Achtung, Test:
        # self.emailProtokoll()

    def emailSenden(self,text,liste,smtp_server,subject="Nachricht",absender="test@test",datei="tmp"):
        if absender not in liste:
            liste.append(absender)
        file = open(verwaltungMainServer.CGI + 'tmp', 'w')
        temptext = """From: %s\nSubject: %s\n%s""" % (absender,subject,text)
        #if verwaltungMainServer.SMTPLIB == 0:
        #    temptext = "From: %s\n" % absender + temptext
        # Achtung, Test:
        #if verwaltungMainServer.DEMOVERSION:
        #    temptext +=  """\nDies ist ein automatisch verteiltes Rundschreiben.\nBitte nicht auf die Absenderadresse\n"%s" antworten.""" % verwaltungMainServer.EMAIL 
        file.write(temptext)
        file.close()
        # protokollieren in Logdatei:
        file = open(verwaltungMainServer.CGI + 'protokoll.txt',"a")
        file.write("""#################\n""" + self.timenow() + "\n" + "Empfnger: "+ string.join(liste) + "\n" + temptext + "\n")
        file.close()
        return self.sendmail(liste,smtp_server=smtp_server,absender=absender,datei=datei)
        

    def sendmail(self,liste,smtp_server,absender="test@test",datei="tmp"):
        """Fr das Versenden einer Reintext-Email aus einer Textdatei heraus (ohne MIME-Anhang).
        text enthlt bereits alle Header im ntigen Format."""
        # Achtung, Test:
        # Absendername
        #if absender is None:
        #    absender = verwaltungMainServer.EMAIL_ADMIN
        if self.win:
            verwaltungMainServer.SMTPLIB = 1 # auf Windows-Systemen immer mit smptlib
        if not verwaltungMainServer.SMTPLIB:
            for adresse in liste:
                befehl =  verwaltungMainServer.SENDMAIL + ' ' + adresse + ' < '  + verwaltungMainServer.CGI + datei
                os.system(befehl)
            file = open(verwaltungMainServer.CGI + datei,"a")
            file.write("""\n\n##################\n\n%s\nDies ist eine Log-Kopie fr den Admin.\nAlle Empfnger: %s""" % (self.timenow(),string.join(liste)))
            file.close()            
            befehl =  verwaltungMainServer.SENDMAIL + ' ' + verwaltungMainServer.EMAIL_ADMIN + ' < '  + verwaltungMainServer.CGI + datei
            os.system(befehl)            
            return 1
        else:
            import smtplib
            file = open(verwaltungMainServer.CGI + datei,"r")
            text = file.read()
            file.close()
            try:
                server = smtplib.SMTP(smtp_server)
                # Achtung, Test:
                server.set_debuglevel(0)
                #server.set_debuglevel(1)
                server.sendmail(absender,liste,text)
                text += """\n\n##################\n\n%s\nDies ist eine Log-Kopie fr den Admin.\nAlle Empfnger: %s""" % (self.timenow(),string.join(liste))
                server.sendmail(absender,verwaltungMainServer.EMAIL_ADMIN,text)
                server.quit()
                return 1
            except:
                print "Content-type: text/html\n"
                print "verwaltungmysql.sendmail: Kann E-Mail nicht senden!"
                return 0

    def emailProtokoll(self,text,Benutzername,nurAdmin="nein"):
        subject = 'Zugriffsprotokoll fr Datenbank %s' % self.Datenbankname
        # Achtung, Test:
        try:
            if nurAdmin == "nein":
                liste = [verwaltungMainServer.CHECKIN[self.Datenbankname][Benutzername][1]]
            else:
                #liste = [verwaltungMainServer.EMAIL_ADMIN] # wird nur an Admin gesendet
                liste = ["dummy@dummy"]
        except:
            liste = [verwaltungMainServer.EMAIL_ADMIN]
        self.emailSenden(text,liste,subject)

    def timenow(self):
        import time
        _time = time.strftime('%d.%m.%Y, %H:%M Uhr', time.localtime(time.time()))
        del time
        return _time

    def selectBefehlDirekt(self,befehl,nurselect="ja"):
        mzliste = []
        select_mysql = re.compile(r"^select",re.IGNORECASE)
        print "SQL-Befehl: ",befehl
        befehl = string.replace(befehl,"\'","\"")
        # keine einfachen Anfhrungszeichen, vgl. den Kommentar in statemysql!
        # Ist aber mglicherweise ein anderes Problem...
        if nurselect == "ja":
            if not select_mysql.search(befehl):
                # Diese und die folgende "seltsame" Rckgabe geht auf die
                # Eigenheiten von gemeindekarteiweb (s.dort) ein.
                return (["Sie drfen nur select-Befehle eingeben!"],[]), mzliste
        try:
            self.Cursor.execute(befehl)
        except:
            return (["SQL-Abfrage nicht mglich! Syntaxfehler?"],[]), mzliste
        templist = self.Cursor.fetchall()
        if not templist:
            templist = (["Kein Eintrag gefunden oder SQL-Befehl liefert keine Rueckgabe!"],[]), mzliste
        else:
            try:                
                tempreg = re.compile(r"select (.*) from")
                mobj = tempreg.search(befehl)
                tempzeile = tuple((mobj.group(1).strip()).split(","))
                templist = (tempzeile,) + templist
                # Die rckgewonnenen Spaltenberschriften werden -
                # typ-korrekt - an den Anfang des Ergebnistupels gestellt.
                try:
                    for i in range(len(tempzeile)):
                        if tempzeile[i] == "MZ":
                            mzliste = [element[i] for element in templist[1:]]
                            # Bei Abfragen, die explizit(nicht mit '*'!) eine MZ erfragen,
                            # wird eine MZ-Liste erstellt, die z.B. fr Serienbriefe
                            # gespeichert wird.
                except:
                    pass
                                       
            except:
                # damit alle Abfragen gehen
                pass            
        return templist,mzliste

    def tabuschluesselEntfernen(self,dict,tabuschluessel):
        for i in dict.keys():
            if i in tabuschluessel:
                del dict[i]
        return dict        

    def verbindungBeenden(self):
        self.Datenbank.close()

    def holeLeerenEintrag(self):
        leerdict = {}
        for i in self.Spaltennamen:
            leerdict[i] = self.Spaltenbeschreibung[i]["Default"]
        return leerdict

    def datumPruefen(self,datum,null_erlauben=1):
	"""Prft ein Datum auf Korrektheit. Wenn null_erlauben=!,
	werden z.B. Leerfelder aus einer Eingabe akzeptiert."""
	flag = 0
	try:
	    d = datumutilities.Datum(datum)
	    flag = 1
	    if not null_erlauben and ("%s" % d == "18000101"):
		flag = 0
	except:
	    pass
	return flag

    def eintragLoeschen(self,primaerschluessel,schluesselwert,tabelle=None):
        if tabelle is None:
            tabelle = self.Tabellenname
        befehl = """delete from %s where %s = "%s" """ % (tabelle,primaerschluessel,schluesselwert)
        self.Cursor.execute(befehl)
        return 1 
    
    def neuerEintrag(self,neudict,primaerschluessel,schluesselwert=None,tabelle=None,strip="ja"):
        # keine kombinierten Primrschlssel mglich!
        # Diese Funktion nicht benutzen, wenn der Primrschlssel per
        # auto_increment erzeugt wird!
        if tabelle is None:
            tabelle = self.Tabellenname
        if strip == "ja":
            neudict = self.dictStrip(neudict)
        if self.Spaltenbeschreibung[primaerschluessel]["Key"] != "PRI" or schluesselwert is None:
            print "Kein korrekter Primaerschluessel fr %s uebergeben!" % primaerschluessel
            return 0
        if self.eintragSuchfunktion({primaerschluessel: schluesselwert})[0]:
            # Dadurch wird sogar das Problem des konkurrierenden Zugriffs abgefangen...?
            print "Primaerschluesselfehler: Wert %s fr %s schon vorhanden!" % (schluesselwert,primaerschluessel)
            return 0
        self.neuerEintragDirekt(neudict,tabelle=tabelle)
        return 1

    def dictStrip(self,dict):
        """Wenn Eintrge z.B. aus einer Eingabemaske vorne oder hinten
        Spaces u.. enthalten."""
        for i in dict.keys():
            try:
                dict[i] = dict[i].strip()
            except:
                # wenn es kein String ist usw.
                pass
        return dict
                

    def neuerEintragDirekt(self,neudict,tabelle=None,strip="ja"):
        """Macht einen neuen Eintrag ohne jede berprfung und Rckfrage.
        Ntzlich z.B., wenn der Primrschlssel per Autoinkrement erzeugt wird.
        Vorsicht beim Gebrauch - lscht vorhandene Primrschlssel rckstandsfrei..."""
        if tabelle is None:
            tabelle = self.Tabellenname
        if strip == "ja":
            neudict = self.dictStrip(neudict)
        keystring,valuestring = ("","")
        for key,value in neudict.items():
            keystring += """%s,""" % key
            valuestring += """"%s",""" % value
            # *** Achtung, den Value keinesfalls nur von einfachen
            # Anfhrungszeichen umschlieen - klappt nicht bei
            # Werten mit Escape-Sequenzen(z.B. Pickles)!!!
        befehl = """insert into %s (%s) values (%s)""" % (tabelle,keystring[:-1],valuestring[:-1])
        #print "\nbefehlNeuerEintrag",befehl
        self.Cursor.execute(befehl)

    def alsDictionary(self,spalten,array):
        # macht aus einem Array von Array ein
        # Array von Dictionaries, jeweils mit den
        # Namen aus "spalten" als Schlssel
        temparray = []
        for i in array:
            tempdict = {}
            for j in range(len(spalten)):
                tempdict[spalten[j]] = i[j]
            temparray.append(tempdict)
        return temparray

    def datumUmwandeln(self,dictarray,kategorie,sprache=None):
        # wandelt aus der Spalte "kategorie" alles
        # in datumutilities.Datum-Objekte um. Wird z.Zt.
        # nicht gebraucht? => Doch - fr die Geburtstagslisten, vgl. gemeindekarteimysql
        if self.Spaltenbeschreibung[kategorie]['Type'] != "date":
            print self.Spaltenbeschreibung[kategorie]
            print "verwaltungmysql.datumUmwandeln: Kann nur Spalten vom Typ date umwandeln!"
            return 0
        else:
            for i in dictarray:
                i[kategorie] = datumutilities.Datum(i[kategorie],sprache)
            return dictarray

    def datumUmwandelnAlle(self,dictarray,sprache=None):
        kategorien = dictarray[0].keys()
        for i in kategorien:
            if self.Spaltenbeschreibung[i]['Type'] == "date":
                dictarray = self.datumUmwandeln(dictarray,i,sprache=sprache)
        return dictarray

    def holeSpaltennamen(self,tabellenname=None):
        # Achtung, Test:
        if tabellenname is None:
            tabellenname = self.Tabellenname
        self.Cursor.execute("""show columns from %s""" % tabellenname)
        temp = self.Cursor.fetchall()
        return [i[0] for i in temp]

    def spaltenBeschreibung(self):
        tempdict_spalten = {}
        self.Cursor.execute("""show columns from %s""" % self.Tabellenname)
        temp = self.Cursor.fetchall()
        beschreibung = ['Type','Null','Key','Default','Extra']
        for i in range(len(self.Spaltennamen)):
            temparray = temp[i]
            tempdict_beschreibungen = {}
            for j in range(0,5):
                # Achtung, in Temparray den ersten Wert auslassen, hier ist
                # immer "Familienstand, Geburtstag" usw.:
                tempdict_beschreibungen[beschreibung[j]] = temparray[j+1]
            tempdict_spalten[temparray[0]] = tempdict_beschreibungen
        return tempdict_spalten                
   

    def eintragHolen(self,where=None,kategorien=None,rueckgabe = "dictionary",tabelle=None,datumumwandeln="nein"):
        # Per Default: alle Spalten bercksichtigen (kategorien = None)
        # Per Default Rckgabe als Dictionary.
        kategorienstring = ""
        spalten = []
        # Achtung, Test:
        ergebnis = []
        if kategorien is None:
            kategorienstring = string.join(self.Spaltennamen,',')
            spalten = self.Spaltennamen
            # Alle Spalten holen
        else:
            kategorienstring = string.join(kategorien,',')
            spalten = kategorien        
        if tabelle is None:
            tabelle = self.Tabellenname
        if where is None:
            # so sind auch Abfragen ohne where mglich
            where = ""
        else:
            where = "where " + where
        befehl = """select %s from %s %s""" % (kategorienstring,tabelle,where)
        self.Cursor.execute(befehl)
        ergebnis = self.Cursor.fetchall()
        if len(ergebnis) == 0:
            #print "Kein Eintrag gefunden!" => Dieser Print produziert einen noch
            # zu klrenden Fehler beim Aufruf des Buchungsformulars.
            # aus Konsistenzgrnden als Rckgabe immer eine Liste(Weiterverarbeitung in
            # den GemeindeverwaltungWeb-Objekten!):
            return [ergebnis]        
        if rueckgabe == "dictionary":
            tempdict = self.alsDictionary(spalten,ergebnis)
            if datumumwandeln == "ja":                
                return self.datumUmwandelnAlle(tempdict)
            else:
                return tempdict
        else:
            return ergebnis

    def oderListeAbfragenBestandteil(self,wert,kategorien,sortierkategorie=None):
        """Fragt ab, ob der Wert Bestandteil in einer beliebigen Kategorie aus
        kategorien vorkommt. Z.B.: Kommt die Abkrzung "LD" als Bestandteil in den Kategorien
        Verantwortung, Mitarbeit vor? Z.B. als "LD; A-Chr.Erz" ?"""
        neuwert = "%" + "%s" % wert + "%"
        # Addition, weil direktes Expandieren von % fehlschlgt.
        return self.oderListeAbfragen(neuwert,kategorien,sortierkategorie=sortierkategorie)

    def oderListeAbfragen(self,wert,kategorien,sortierkategorie=None,zusatzbedingung=""):
        """Fragt ab, ob der Wert in einer beliebigen Kategorie (als Liste kategorien bergeben)
        vorkommt."""
        wherestring = ""
        for i in kategorien:
            wherestring += """%s like "%s" or """ % (i,wert)
        wherestring = wherestring[:-3]
        # das letzte or kommt weg, es werden immer alle Spalten zurckgegeben, immer ein Dict.
        if zusatzbedingung != "":
            wherestring = "(%s) %s " % (wherestring,zusatzbedingung)
            # Klammern fr Zusammenfassung der ursprnglichen Bedingungen)
        if sortierkategorie is not None:
            wherestring += "order by %s" % sortierkategorie
        return self.eintragHolen(wherestring)

    def listeAlsSQL(self,liste):
        if not liste:
            return """("-")"""
        """Wandelt eine Liste in einen SQL-String fr eine where-Abfrage
        um, z.B. in ("305","306")."""
        temp = "("
        for i in liste:
            temp += """"%s",""" % i
        temp = temp[:-1] + ")"
        # das letzte Komma durch eine schlieende Klammer ersetzen
        return temp
        

    def eintragAendern(self,aenderungsdict,primaerschluessel,schluesselwert):
        # "primaerschluessel" ist der Primrschlssel der Tabelle. Er kann mit dieser
        # Funktion nicht gendert werden.
        # print self,aenderungsdict,primaerschluessel,schluesselwert
        for i in aenderungsdict.keys():
            befehl = """update %s set %s="%s" where %s="%s" """ % (self.Tabellenname,i,aenderungsdict[i],primaerschluessel,schluesselwert)
            if self.Spaltenbeschreibung[i]["Key"] != "PRI":
                # Prfung, ob Primrschlssel
                self.Cursor.execute(befehl)
            else:
                print "Content-type: text/plain\n"
                # fr CGI-Skripte zum Debuggen
                print "verwaltungsmysql.eintragAendern: Kann Primrschlssel %s nicht ndern" % i
           
    def letzterAutoEintrag(self):
        """Gibt den letzten Auto_Increment-Eintrag zurck, fr jeden Client getrennt!"""
        self.Cursor.execute("""select last_insert_id()""")
        return self.Cursor.fetchall()[0][0]

    def wertVorhanden(self,kategorie,wert):
        temp = self.eintragSuchfunktion({kategorie: wert})
        if temp[0]:
            return 1
        else:
            return 0

    def wertUnique(self,kategorie,wert):
        if len(self.eintragSuchfunktion({kategorie: wert})) == 1:
            return 1
        else:
            return 0

    def werteListe(self,kategorie,distinct="nein",wherestring="",leere_entfernen="nein"):
        """Gibt alle Werte einer Kategorie zurck als Liste."""
        if distinct == "nein":
            befehl = """select %s from %s %s order by %s""" % (kategorie,self.Tabellenname,wherestring,kategorie)
        else:
            befehl = """select distinct %s from %s %s order by %s""" % (kategorie,self.Tabellenname,wherestring,kategorie)
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall()
        liste = []
        for i in temp:
            if leere_entfernen == "nein":
                liste.append(i[0])
            elif leere_entfernen == "ja":
                if i[0] != "-" and i[0] != "None":
                    liste.append(i[0])
        return liste

    def kategorieUnique(self,kategorie):
        """Zeigt an, ob alle Werte in einer Kategorie nur einmal vorkommen."""
        if len(self.werteListe(kategorie,distinct="ja")) == len(self.werteListe(kategorie)):
            return 1
        else:
            return 0

    def oderAbfrageAlsSQL(self,abfragetext,kategorie):
        """Ermglicht es in Eingabeformularen "ODER" zu setzen. Fehlt es, wird eine einfache SQL-Abfrage
        zurckgegeben."""
        liste = abfragetext.split("ODER")
        liste = [string.strip(i) for i in liste]
        if len(liste) == 1:
            return """%s like "%s" """ % (kategorie,liste[0])
        else:
            temp = "("
            for i in liste:
                temp += """%s like "%s" or """ % (kategorie,i)
            return temp[:-3] + ")"

    def eintragSuchfunktion(self,suchdict,datumumwandeln="nein",tabelle=None,sortierkategorie=None,leerquery=None):
        if leerquery is None:
            leerquery = """(dictwert is Null or dictwert like "-" or dictwert like "" or dictwert like "0000-00-00")"""
        if tabelle is None:
            tabelle = self.Tabellenname
        querystring = ""
        for i in suchdict.keys():
            tempstring = string.strip("%s" % suchdict[i])
            # normieren auf String-Format ohne Leerzeichen vorne und hinten.
            # tempstring = suchdict[i]
            if tempstring in ("NEIN","JA"):
                leerquery = string.replace(leerquery,"dictwert",i)
                if tempstring == "NEIN":
                    querystring += leerquery + " AND "
                else:
                    querystring += "not " + leerquery + " AND " 
            elif tempstring != "":                
                tempstring = string.replace(tempstring,'?','_')
                tempstring = string.replace(tempstring,'*','%')
                # Alte DOS-Gewohnheiten fr Wildcards werden umgewandelt
                # auf das MySQL-Format
                # querystring += """%s like "%s" AND """ % (i,tempstring) # neu mit ODER-Abfrage:
                querystring += """%s AND """ % self.oderAbfrageAlsSQL(tempstring,i)
        if querystring != "":
            querystring = querystring[:-4]
            if sortierkategorie is not None:
                querystring += """order by %s""" % sortierkategorie
            # Das letzte "AND" wird nicht bentigt
            return self.eintragHolen(where=querystring,tabelle=tabelle,datumumwandeln=datumumwandeln)
        else:
            return {}

    def eintragVergleichen(self,suchdict,vergleichdict,nichtvergleichen=[]):
        # *** Was ist, wenn die nderung in der "Lschung" einer ganzen
        # *** Kategorie besteht (z.B. Eintrag auf "" setzen)? => Fehlfunktion!
        # *** Das mu in den Subklassen ggf. behandelt werden!
        # Es sollen immer nur zwei einzelne Dicts miteinander verglichen werden!
        # Deshalb der Index[0] am Schlu:
        urdict = self.eintragSuchfunktion(suchdict,datumumwandeln="nein")[0]
        # ** Keine Defaultsuche beim Vergleich - die ist ja z.T. in den Subklassen aktiviert!
        # *** Noch auf nichtgefundene Eintrge prfen? ***
        # *** Man knnte auch prfen (sinnvoll?), ob es sich um einen
        # bei suchdict um einen Primrschlssel handelt. Letzteres lt
        # sich sinnvoll in den Subklassen erledigen.
        vergleichschluessel = vergleichdict.keys()
        urschluessel = urdict.keys()
        for i in vergleichschluessel:
            if i not in urschluessel:
                print "verwaltungmysql.eintragVergleichen: Falsche Vergleichsschlssel!"
                return {}
        rueckgabedict = {}
        for i in vergleichschluessel:
            if i not in nichtvergleichen:
                if ("%s" % urdict[i]) != ("%s" % vergleichdict[i]):
                    # Zum korrekten Vergleich wird hier alles auf Strings normiert!!
                    # Wichtig besonders fr das Datumsformat.
                    rueckgabedict[i] = ["%s" % urdict[i],"%s" % vergleichdict[i]]
        return rueckgabedict   

            
    def alleSchluesselHolen(self):
        pass

    def alleAlsListe(self):
        befehl = """select * from %s""" % (self.Tabellenname,)
        self.Cursor.execute(befehl)
        return self.Cursor.fetchall()

    def alleAlsDictionary(self):
        """Wie "alsListe", aber mit dict als Rckgabe."""
        temp = self.alleAlsListe()
        return self.alsDictionary(self.Spaltennamen,temp)

    def spaltenAlsString(self,spaltenliste):
        """Wandelt eine Liste mit Spaltennamen in einen
        SQL-String um. Prft auf Korrektheit."""
        spaltenstring = ""
        for i in spaltenliste:
            if i in self.Spaltennamen:
                spaltenstring += i+","
            else:
                print "verwaltungmysql: nichtexistierende Spalten abgefragt!"
                return 0
        # Das letzte Komma weg:
        return spaltenstring[:-1] 

    def sortierteListe(self,sortierkategorie,spaltenliste=None,rueckgabe="dictionary",where="",tabelle=None):
        # eine beliebige Sortierung, funktioniert auch fr den Date-Typ von MySQL
        # Achtung, geht nicht korrekt fr die Sortierung mit deutschen Umlauten!
        if tabelle is None:
            tabelle = self.Tabellenname
        spalten = ""
        if spaltenliste is None:
            spalten = "*"
        else:
            spalten = self.spaltenAlsString(spaltenliste)            
        befehl = """select %s from %s %s order by %s""" % (spalten,tabelle,where,sortierkategorie)
        self.Cursor.execute(befehl)
        liste= self.Cursor.fetchall()
        if rueckgabe == "dictionary":
            return self.alsDictionary(self.Spaltennamen,liste)
        else:
            return liste
    
    def JahresListe(self,sortierkategorie,spalten=None,rueckgabe="dictionary",where=""):
        # eine Datums-Liste, geordnet nach dem Platz eines Datums im Jahr. MySQL hat hier einen Bug,
        # die letzten Tage des Jahres werden so nicht korrekt geordnet.
        if spalten is None:
           spalten_text = "*"
        else:
           spalten_text = string.join(spalten,',')
           # fr die korrekte MySQL-Syntax Umwandlung des Tupels/Arrays
        befehl = """select %s,dayofyear(%s) as val from %s %s order by val""" % (spalten_text,sortierkategorie,self.Tabellenname,where)
        #print "befehl",befehl
        self.Cursor.execute(befehl)
        liste = self.Cursor.fetchall()
        liste = [i[:-1] for i in liste]
        # Der val-Wert - der am Schlu steht - wird nicht bentigt
        if rueckgabe == "dictionary":
            return self.alsDictionary(self.Spaltennamen,liste)
        else:
            return liste


    def mysqlDatumUmwandeln(self,wert):
        """Wandelt das Datumsformat von MySQL in ein bliches
        deutsches Format um.
        Man knnte die ganze Funktion auch nach Textutilities verlagern..."""
        mobj = self.datum_mysql.search(wert)
        if mobj is not None:
            wert = mobj.group(2)+mobj.group(3)+mobj.group(4)
            datum = datumutilities.Datum(wert)
            return datum.deutschesFormatText()
        else:
            return wert

    def alleTabellen(self,datenbank=None):
        """Gibt alle Tabellen der aktuellen Datenbank zurck als Liste."""
        if datenbank is None:
            datenbank = self.Datenbankname
        befehl = """show tables from %s""" % datenbank
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall()
        return [i[0] for i in temp]

    def eigeneDatenbanken(self):
        """Gibt alle Datenbanken auer mysql und test zurck."""
        templist = []
        for i in self.alleDatenbanken():
            if (i != "test") and (i != "mysql"):
                templist.append(i)
        return templist

    def alleDatenbanken(self):
        """Gibt alle in Mysql gespeicherten Datenbanken zurck als Liste."""
        befehl = """show databases"""
        self.Cursor.execute(befehl)
        temp = self.Cursor.fetchall()
        return [i[0] for i in temp]

    def tabelleKopieren(self,alteTabelle,neueTabelle,Mysqlverzeichnis,mitDaten="nein", erzwingen="nein",neueDatenbank=""):
        """Kopiert die Struktur einer Tabelle, ggf. mit den Daten darin.
        Benutzt dazu mysqldump, das geht auch in Version 3.22. Unter neueDatenbank kann ein Datenbankname
        bergeben werden. Das wird gebraucht, wenn eine Kopie einer ganzen Datenbank erstellt werden soll.
        """
        if neueDatenbank == "":
            neueDatenbank = self.Datenbankname
        if neueTabelle in self.alleTabellen() and erzwingen != "ja":
            print "Die neue Tabelle %s existiert schon. Kopiervorgang abgebrochen!" % neueTabelle
            return 0
        Mysqlverzeichnis = os.path.normpath(Mysqlverzeichnis)
        dir = os.getcwd()
        test = 0        
        temptable = "temptable.sql"
        if self.win:
            os.chmod(Mysqlverzeichnis,0777)
            os.chdir(Mysqlverzeichnis)
            # dort sollte natrlich Schreibberechtigung sein...
            # am Schlu mssen wir wieder nach dir wechseln, sonst gibt es
            # Probleme mit dem CGI-Server.
        if mitDaten == "ja":
            mitDaten = ""
        else:
            mitDaten = "--no-data"
        if self.win:
            test = os.system("""%s %s %s %s > %s""" % (self.mysqldump,mitDaten,self.Datenbankname,alteTabelle,temptable))
        else:
            test = os.system("""mysqldump -u %s --password=%s %s %s %s > %s""" % (verwaltungMainServer.datenbank_user,verwaltungMainServer.datenbank_passwort,mitDaten,self.Datenbankname,alteTabelle,temptable))
        # Die alte Tabellenbezeichnung wird im SQL-Dump ersetzt:       
        self.Textwerkzeug.stringErsetzenDatei(temptable,alteTabelle,neueTabelle)
        if self.win:
            test = os.system("""%s %s < %s""" % (self.mysql,neueDatenbank,temptable))
        else:
            test = os.system("""mysql -u %s --password=%s %s < %s""" % (verwaltungMainServer.datenbank_user,verwaltungMainServer.datenbank_passwort,neueDatenbank,temptable))
        try:
            os.chmod(temptable,0777)
            time.sleep(1)
            os.remove(temptable)
            # ein Patch fr Windows, weil manchmal die Schreibberechtigung
            # fr temptable (warum? Das File ist geschlossen!) verweigert wird.
        except:
            print "temptable.sql konnte nicht entfernt werden!"
        # aufrumen...
        os.chdir(dir)
        # zurck ins Server-Verzeichnis (Windows!)
        if test:
            print """Kopieren von Tabelle %s nach Tabelle %s fehlgeschlagen!""" % (alteTabelle, neueTabelle) 
            return 0
        else:
            return 1
       
    def sichernMysqldump(self,Datenbank,Sicherungsverzeichnis,Mysqlverzeichnis,ruecksichern="nein",rueckdatei=""):
        """Sichert eine Datenbank als SQL-Dump. Tests haben ergeben, da dabei eine
        Komprimierung (etwa mit zipfile) nichts bringt, ja den Dump sogar noch
        vergrert. Wird auch zum Rcksichern mit automatischer vorheriger Sicherung verwendet."""
        test = 0
        startverzeichnis = os.getcwd()
        Sicherungsverzeichnis = os.path.normpath(Sicherungsverzeichnis)
        # Die normpath-Befehle beseitigen Schwierigkeiten unter Windows, die sich bei
        # Tests gezeigt haben.
        Mysqlverzeichnis = os.path.normpath(Mysqlverzeichnis)
        dateibezeichnung = "%sbackup_%s" % (Datenbank,self.Datumwerkzeug.zeitstempel())
        sicherungsdatei = os.path.normpath(os.path.join(Sicherungsverzeichnis,"%s.sql" % dateibezeichnung))
        if rueckdatei != "":
            rueckdatei = os.path.normpath(os.path.join(Sicherungsverzeichnis,rueckdatei))       
        if self.win:
            os.chdir(Mysqlverzeichnis)
            # Das Mysql-Verzeichnis wird mit bergeben, falls es bei Windows nicht im Suchpfad liegt.
            # Tests haben ergeben, da man mysqldump aus dem eigenen Verzeichnis starten sollte. 
            test = os.system("""%s --add-drop-table %s > %s""" % (self.mysqldump,Datenbank,sicherungsdatei))
        else:
            test = os.system("""mysqldump -u %s --password=%s --add-drop-table %s > %s""" % (verwaltungMainServer.datenbank_user,verwaltungMainServer.datenbank_passwort,Datenbank,sicherungsdatei))
        if not os.path.exists(Sicherungsverzeichnis):
            # Zusatztest speziell fr Windows - hier gibt os.system keine exakte Fehlermeldung, oder?
            test = 1
            print "Sicherungsverzeichnis %s existiert nicht!" % Sicherungsverzeichnis
        if test and ruecksichern != "ja":
            print "Fehler bei Datensicherung!"
            os.chdir(startverzeichnis)
            return "keiner Datei! Nicht vergessen: Schreibrechte fr Sicherungsverzeichnis prfen!"
        elif test and ruecksichern == "ja":
            print "Fehler beim automatischen Backup vor der Rcksicherung."
            os.chdir(startverzeichnis)
            return "keiner Datei!"
        if ruecksichern != "ja":
            os.chdir(startverzeichnis)
            return "%s" % sicherungsdatei
        elif ruecksichern == "ja":
            if self.win:
                os.chdir(Mysqlverzeichnis)
                test = os.system("""%s %s < %s""" % (self.mysql, Datenbank, rueckdatei))
            else:
                test = os.system("""mysql -u %s --password=%s %s < %s""" % (verwaltungMainServer.datenbank_user,verwaltungMainServer.datenbank_passwort,Datenbank, rueckdatei))
            if test:
                print "Fehler beim Rcksichern!"
                os.chdir(startverzeichnis)
                return "keiner Datei! Rcksicherungsdatei korrumpiert?"
            else:
                os.chdir(startverzeichnis)
                return "%s" % rueckdatei
                                 

    
       
